<?xml version="1.0" encoding="UTF-8"?>
<!--
	Checks TestMetadata.xml for presence of root WSDL document.
	
	ChangeLog:
	
	2006-11-17: Arthur Ryman (ryman@ca.ibm.com)
	- created
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	exclude-result-prefixes="tm"
	xmlns:tm="http://www.w3.org/2006/02/wsdl/TestMetadata" version="1.0">

	<xsl:strip-space elements="*" />
	<xsl:output method="xml" indent="yes" />

	<xsl:template match="/">
		<MissingRoots>
			<xsl:for-each select='test-suite/test-case'>
				<xsl:variable name='test-id' select='@id' />
				<xsl:for-each
					select="document(@href)/tm:TestMetadata//tm:Inputs">
					<xsl:if test="not(tm:Input[@role='root'])">
						<xsl:message>
							<xsl:text>Error: Missing role='root' attribute on Input in TestMetadata.xml for test case&#x20;</xsl:text>
							<xsl:value-of select="$test-id" />
						</xsl:message>
						<MissingRoot test-id='{$test-id}' />
					</xsl:if>
				</xsl:for-each>
			</xsl:for-each>
		</MissingRoots>
	</xsl:template>

</xsl:stylesheet>
