<?xml version="1.0" encoding="UTF-8"?>
<!--
 This is a style sheet, generated by evaluate-html-log-xsl.xslt.
 ******** DO NOT EDIT *********
-->
<xsl:stylesheet xmlns:soap11="http://schemas.xmlsoap.org/soap/envelope/" xmlns:soap12="http://www.w3.org/2003/05/soap-envelope" xmlns:module="http://www.w3.org/2002/ws/desc/6/10/test-module" xmlns:l="http://www.w3.org/2002/ws/desc/logs/" xmlns:m="http://www.w3.org/2006/11/desc/messages" xmlns:a="http://www.w3.org/2006/11/desc/assertions" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" l:fake="false">
<xsl:param name="DSTAMP"/>
<xsl:param name="TSTAMP"/>
<xsl:param name="TODAY"/>
<xsl:param name="logfile"/>
<xsl:output method="html"/>
<xsl:template match="/">
<html>
<head>
<title>Results</title>
<meta content="text/html; charset=UTF-8" http-equiv="Content-Type"/>
<style type="text/css">
	        body {font-family:sans-serif}
	        td {vertical-align:top; border-top:1px solid gray}
	        .passed {width:4em; background-color:green; text-align:center}
	        .failed {width:4em; background-color:red; text-align:center}
	        .assertion {padding-bottom:.5em}
        </style>
</head>
<body>
<h1>Message exchange test results</h1>
<p>Generated <xsl:value-of select="$TODAY"/>,
	    <xsl:value-of select="$TSTAMP"/>
</p>
<h2>From
	      <xsl:call-template name="find-agent">
<xsl:with-param name="message" select="/l:log/l:message[@type=&quot;request&quot;]"/>
</xsl:call-template>
	      to
	      <xsl:call-template name="find-agent">
<xsl:with-param name="message" select="/l:log/l:message[@type=&quot;response&quot;]"/>
</xsl:call-template>
</h2>
<div>
<xsl:if test="count(/l:log/l:message)!=8">
<p style="color:red;font-size: 150%;">Only got
		<xsl:value-of select="count(/l:log/l:message)"/>
		out of 8</p>
</xsl:if>
</div>
<div>
<xsl:apply-templates select="/l:log/l:message"/>
</div>
</body>
</html>
</xsl:template>
<xsl:template name="find-agent">
<xsl:param name="message"/>
<xsl:choose>
<xsl:when test="$message/l:httpHeaders/l:Server">
<xsl:value-of select="$message/l:httpHeaders/l:Server"/>
</xsl:when>
<xsl:when test="$message/l:httpHeaders/l:User-Agent">
<xsl:value-of select="$message/l:httpHeaders/l:User-Agent"/>
</xsl:when>
<xsl:otherwise>Unknown</xsl:otherwise>
</xsl:choose>
</xsl:template>
<xsl:template match="l:message[@number=&quot;1&quot;]">
<hr/>
<h3 id="message1">Message 1 (request)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{EchoName}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-out</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/iri</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/multipart</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;1&quot;]/@type=&quot;request&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="1"]/@type="request"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="1"]/@type="request"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="contains(/l:log/l:message[@number=&quot;1&quot;]/l:httpHeaders/l:Method/@rawURI, &quot;EchoName?first=myfirst;middle=mymiddle;last=mylast&quot;)">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="1"]/l:httpHeaders/l:Method/@rawURI, "EchoName?first=myfirst;middle=mymiddle;last=mylast")</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="1"]/l:httpHeaders/l:Method/@rawURI, "EchoName?first=myfirst;middle=mymiddle;last=mylast")</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;1&quot;]/l:httpHeaders/l:Method/@value='POST'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="1"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="1"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;1&quot;]/l:content/text())&gt;0">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="1"]/l:content/text())&gt;0</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="1"]/l:content/text())&gt;0</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message1')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;2&quot;]">
<hr/>
<h3 id="message2">Message 2 (response)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{EchoName}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-out</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/iri</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/multipart</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;2&quot;]/@type=&quot;response&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/@type="response"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/@type="response"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;2&quot;]/l:httpHeaders/l:Content-Type/@type='application/xml'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;2&quot;]/l:httpHeaders/l:StatusCode/@value='200'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:httpHeaders/l:StatusCode/@value='200'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:httpHeaders/l:StatusCode/@value='200'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;2&quot;]/l:content/*)=1">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="2"]/l:content/*)=1</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="2"]/l:content/*)=1</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;2&quot;]/l:content/*[local-name()='EchoName' and namespace-uri()='http://example.org/message-test/xsd']">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:content/*[local-name()='EchoName' and namespace-uri()='http://example.org/message-test/xsd']</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="2"]/l:content/*[local-name()='EchoName' and namespace-uri()='http://example.org/message-test/xsd']</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message2')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;3&quot;]">
<hr/>
<h3 id="message3">Message 3 (request)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{EchoNameExpectFault}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-out</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/iri</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;3&quot;]/@type=&quot;request&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="3"]/@type="request"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="3"]/@type="request"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="contains(/l:log/l:message[@number=&quot;3&quot;]/l:httpHeaders/l:Method/@rawURI, &quot;EchoNameExpectFault&quot;)">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="3"]/l:httpHeaders/l:Method/@rawURI, "EchoNameExpectFault")</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="3"]/l:httpHeaders/l:Method/@rawURI, "EchoNameExpectFault")</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;3&quot;]/l:httpHeaders/l:Method/@value='POST'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="3"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="3"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;3&quot;]/l:content/text())&gt;0">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="3"]/l:content/text())&gt;0</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="3"]/l:content/text())&gt;0</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message3')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;4&quot;]">
<hr/>
<h3 id="message4">Message 4 (response)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{EchoNameExpectFault}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-out</code>
<br/>Style <code>http://www.w3.org/ns/wsdl/style/iri</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;4&quot;]/@type=&quot;response&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/@type="response"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/@type="response"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;4&quot;]/l:httpHeaders/l:Content-Type/@type='application/xml'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;4&quot;]/l:httpHeaders/l:StatusCode/@value='500'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:httpHeaders/l:StatusCode/@value='500'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:httpHeaders/l:StatusCode/@value='500'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;4&quot;]/l:content/*)=1">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="4"]/l:content/*)=1</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="4"]/l:content/*)=1</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;4&quot;]/l:content/*[local-name()=&quot;EchoNameFault&quot; and namespace-uri()=&quot;http://example.org/message-test/xsd&quot;]">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:content/*[local-name()="EchoNameFault" and namespace-uri()="http://example.org/message-test/xsd"]</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="4"]/l:content/*[local-name()="EchoNameFault" and namespace-uri()="http://example.org/message-test/xsd"]</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message4')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;5&quot;]">
<hr/>
<h3 id="message5">Message 5 (request)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{Send}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-only</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;5&quot;]/@type=&quot;request&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="5"]/@type="request"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="5"]/@type="request"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="contains(/l:log/l:message[@number=&quot;5&quot;]/l:httpHeaders/l:Method/@rawURI, &quot;Send&quot;)">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="5"]/l:httpHeaders/l:Method/@rawURI, "Send")</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="5"]/l:httpHeaders/l:Method/@rawURI, "Send")</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;5&quot;]/l:httpHeaders/l:Method/@value='POST'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="5"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="5"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;5&quot;]/l:content/*)&lt;=1">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="5"]/l:content/*)&lt;=1</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="5"]/l:content/*)&lt;=1</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message5')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;6&quot;]">
<hr/>
<h3 id="message6">Message 6 (response)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{Send}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/in-only</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;6&quot;]/@type=&quot;response&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="6"]/@type="response"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="6"]/@type="response"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;6&quot;]/l:httpHeaders/l:StatusCode/@value='202'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="6"]/l:httpHeaders/l:StatusCode/@value='202'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="6"]/l:httpHeaders/l:StatusCode/@value='202'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message6')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;7&quot;]">
<hr/>
<h3 id="message7">Message 7 (request)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{GuaranteedFault}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/robust-in-only</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;7&quot;]/@type=&quot;request&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="7"]/@type="request"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="7"]/@type="request"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="contains(/l:log/l:message[@number=&quot;7&quot;]/l:httpHeaders/l:Method/@rawURI, &quot;GuaranteedFault&quot;)">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="7"]/l:httpHeaders/l:Method/@rawURI, "GuaranteedFault")</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">contains(/l:log/l:message[@number="7"]/l:httpHeaders/l:Method/@rawURI, "GuaranteedFault")</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;7&quot;]/l:httpHeaders/l:Method/@value='POST'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="7"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="7"]/l:httpHeaders/l:Method/@value='POST'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;7&quot;]/l:content/*)=0">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="7"]/l:content/*)=0</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="7"]/l:content/*)=0</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message7')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
<xsl:template match="l:message[@number=&quot;8&quot;]">
<hr/>
<h3 id="message8">Message 8 (response)
	    <if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:senderHostAndPort"> [<code xmlns="" class="from">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:senderHostAndPort"/>
</code>
</if>
<if xmlns="http://www.w3.org/1999/XSL/Transform" test="l:receiverHostAndPort"> ⇨ <code xmlns="" class="to">
<value-of xmlns="http://www.w3.org/1999/XSL/Transform" select="l:receiverHostAndPort"/>
</code>
</if>]</h3>
<p style="font-size:small">EndpointComponent <code>MessageTestMultipartHTTP</code>
<br/>BindingComponent <code>http://example.org/message-test{EchoMultipartHTTPBinding}</code>
<br/>Operation <code>http://example.org/message-test{GuaranteedFault}</code>
<br/>WSDL MEP <code>http://www.w3.org/ns/wsdl/robust-in-only</code>
<br/>
</p>
<table cellpadding="0" cell-spacing="0">
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;8&quot;]/@type=&quot;response&quot;">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/@type="response"</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/@type="response"</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;8&quot;]/l:httpHeaders/l:Content-Type/@type='application/xml'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:httpHeaders/l:Content-Type/@type='application/xml'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;8&quot;]/l:httpHeaders/l:StatusCode/@value='500'">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:httpHeaders/l:StatusCode/@value='500'</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:httpHeaders/l:StatusCode/@value='500'</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="count(/l:log/l:message[@number=&quot;8&quot;]/l:content/*)=1">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="8"]/l:content/*)=1</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">count(/l:log/l:message[@number="8"]/l:content/*)=1</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
<xsl:choose>
<xsl:when test="/l:log/l:message[@number=&quot;8&quot;]/l:content/*[local-name()=&quot;EchoNameFault&quot; and namespace-uri()=&quot;http://example.org/message-test/xsd&quot;]">
<tr>
<td class="passed">
<div>OK</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:content/*[local-name()="EchoNameFault" and namespace-uri()="http://example.org/message-test/xsd"]</div>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td class="failed">
<div class="failed">FAILED</div>
</td>
<td>
<div class="assertion">/l:log/l:message[@number="8"]/l:content/*[local-name()="EchoNameFault" and namespace-uri()="http://example.org/message-test/xsd"]</div>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</table>
<p>
<a>
<xsl:attribute name="href">
<xsl:value-of select="concat($logfile,'#message8')"/>
</xsl:attribute>view log</a>
</p>
</xsl:template>
</xsl:stylesheet>
