<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    
    <xsl:output method="xml" indent="yes"/>
    
    <xsl:template match="/">
        <xsl:processing-instruction name="xml-stylesheet">type="text/xsl" href="message-tests-results.xsl"</xsl:processing-instruction>
        <message-test-summary>
            <xsl:copy-of select="logs/implementations"/>
            <xsl:for-each select="logs/test">
                <xsl:variable name="test-id" select="@id"/>
                <xsl:variable name="logs" select="document(log)"/>
                <testpass id="{$test-id}" binding="{@binding}">
                    <xsl:variable name="log-metadata" select="log"/>
                    <logs>
                        <xsl:for-each select="$log-metadata">
                            <log id="{@id}" client="{@client}" service="{@service}"
                            href="{.}"/>
                        </xsl:for-each>
                    </logs>
                    <xsl:for-each select="$logs[1]">
                        <xsl:for-each select="resultSets/resultSet">
                            <xsl:variable name="test-number" select="@number"/>
                            <test number="{$test-number}">
                                <xsl:for-each select="$logs">
                                    <xsl:variable name="position" select="position()"/>
                                    <xsl:for-each select="resultSets/resultSet[@number=$test-number]">
                                        <result implementation="{$log-metadata[position()=$position]/@id}">
                                            <xsl:choose>
                                                <xsl:when test="test[@result != 'passed']">failed</xsl:when>
                                                <xsl:otherwise>passed</xsl:otherwise>
                                            </xsl:choose>
                                        </result>
                                    </xsl:for-each>
                                </xsl:for-each>
                            </test>
                        </xsl:for-each>
                    </xsl:for-each>                        
                </testpass>
            </xsl:for-each>
        </message-test-summary>
    </xsl:template>
</xsl:stylesheet>