<?xml version="1.0" encoding="UTF-8"?>
<!--

    $Header: /sources/public/2002/ws/desc/test-suite/results-messages/ws-i.xslt,v 1.6 2007/02/22 23:21:28 jonathanMarsh Exp $

    Convert WS-I Monitor file into WS-Addressing Log file

-->
<xsl:stylesheet version="1.0"
		xmlns="http://www.w3.org/2002/ws/desc/logs/"
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
		xmlns:wsi-log303="http://www.ws-i.org/testing/2003/03/log/"
		xmlns:wsi-log407="http://www.ws-i.org/testing/2004/07/log/"
		exclude-result-prefixes='wsi-log303 wsi-log407'>
	<xsl:output method="xml" indent="yes"/>
	<xsl:variable name="bom">&lt;?xml</xsl:variable>
	<xsl:variable name="gone">&lt;?_xml</xsl:variable>
	<xsl:template match="wsi-log303:log">
		<xsl:processing-instruction name="xml-stylesheet">type="text/xsl" href="../defaultss-msgnum.xslt"</xsl:processing-instruction>
		<log xmlns:l="http://www.w3.org/2002/ws/addressing/logs/">
			<xsl:for-each select="//wsi-log303:messageEntry">
				<xsl:variable name="content">
				  <xsl:variable name="fixed_content">
				    <xsl:choose>
				      <xsl:when test='contains(wsi-log303:httpHeaders, "&lt;?xml")
						      and contains(wsi-log303:messageContent, "&lt;?xml")'>
					<xsl:text>&lt;?xml</xsl:text>
					<xsl:value-of select="substring-after(wsi-log303:messageContent, '&lt;?xml')"/>
				      </xsl:when>
				      <xsl:otherwise>
					<xsl:value-of select="wsi-log303:messageContent"/>
				      </xsl:otherwise>
				    </xsl:choose>
				  </xsl:variable>
				  <xsl:choose>
				    <xsl:when test='contains(wsi-log303:httpHeaders, "Content-Type: text/xml")
						    or contains(wsi-log303:httpHeaders, "Content-Type: application/soap+xml")'>
					<xsl:call-template name="replaceContent">
						<xsl:with-param name="text" select="$fixed_content"/>
						<xsl:with-param name="replace" select="$bom"/>
						<xsl:with-param name="with" select="$gone"/>
						<xsl:with-param name="disable-output-escaping" select="yes"/>
					</xsl:call-template>
				    </xsl:when>
				    <xsl:otherwise>
				      <xsl:value-of select="$fixed_content"/>
				    </xsl:otherwise>
				  </xsl:choose>
				</xsl:variable>
				<message timestamp="{@timestamp}" conversation="{@conversationID}" number="{@ID}" type="{@type}">
				  <senderHostAndPort>
				    <xsl:copy-of select="wsi-log303:senderHostAndPort/@*"/>
				    <xsl:copy-of select="wsi-log303:senderHostAndPort/*|wsi-log303:senderHostAndPort/text()"/>
				  </senderHostAndPort>
				  <receiverHostAndPort>
				    <xsl:copy-of select="wsi-log303:receiverHostAndPort/@*"/>
				    <xsl:copy-of select="wsi-log303:receiverHostAndPort/*|wsi-log303:receiverHostAndPort/text()"/>
				  </receiverHostAndPort>
				  <httpHeaders>
				    <xsl:call-template name='replaceHeaders'>
				      <xsl:with-param name="text">
					<xsl:choose>
					  <xsl:when test='contains(wsi-log303:httpHeaders, "&lt;?xml")
							  and contains(wsi-log303:messageContent, "&lt;?xml")'>
					    <xsl:value-of select="substring-before(wsi-log303:httpHeaders, '&lt;?xml')"/>
					  </xsl:when>
					  <xsl:otherwise>
					    <xsl:value-of select="wsi-log303:httpHeaders"/>
					  </xsl:otherwise>
					</xsl:choose>
				      </xsl:with-param>
				    </xsl:call-template>
				  </httpHeaders>
				  <content>
				    <xsl:choose>
				      <xsl:when test='contains($content, "&lt;!DOCTYPE")'>					
					<xsl:value-of select="$content" />
				      </xsl:when>
				      <xsl:otherwise>
					<xsl:value-of select="$content" disable-output-escaping="yes"/>
				      </xsl:otherwise>
				    </xsl:choose>
				  </content>
				</message>
			</xsl:for-each>
		</log>
	</xsl:template>
	<xsl:template match="wsi-log407:log">
		<xsl:processing-instruction name="xml-stylesheet">type="text/xsl" href="../defaultss-msgnum.xslt"</xsl:processing-instruction>
		<log>
			<xsl:for-each select="//wsi-log407:messageEntry">
				<xsl:variable name="content">
				  <xsl:variable name="fixed_content">
				    <xsl:choose>
				      <xsl:when test='contains(wsi-log407:httpHeaders, "&lt;?xml")
						      and contains(wsi-log407:messageContent, "&lt;?xml")'>
					<xsl:text>&lt;?xml</xsl:text>
					<xsl:value-of select="substring-after(wsi-log407:messageContent, '&lt;?xml')"/>
				      </xsl:when>
				      <xsl:otherwise>
					<xsl:value-of select="wsi-log407:messageContent"/>
				      </xsl:otherwise>
				    </xsl:choose>
				  </xsl:variable>
				  <xsl:choose>
				    <xsl:when test='contains(wsi-log407:httpHeaders, "Content-Type: text/xml")
						    or contains(wsi-log407:httpHeaders, "Content-Type: application/soap+xml")
						    or contains(wsi-log407:httpHeaders, "Content-Type: application/echo+xml")
						    or contains(wsi-log407:httpHeaders, "Content-Type: application/xml")'>
					<xsl:call-template name="replaceContent">
						<xsl:with-param name="text" select="$fixed_content"/>
						<xsl:with-param name="replace" select="$bom"/>
						<xsl:with-param name="with" select="$gone"/>
						<xsl:with-param name="disable-output-escaping" select="yes"/>
					</xsl:call-template>
				    </xsl:when>
				    <xsl:otherwise>
				      <xsl:value-of select="$fixed_content"/>
				    </xsl:otherwise>
				  </xsl:choose>
				</xsl:variable>
				<message timestamp="{@timestamp}" conversation="{@conversationID}" number="{@ID}" type="{@type}">
				  <senderHostAndPort>
				    <xsl:copy-of select="wsi-log407:senderHostAndPort/@*"/>
				    <xsl:copy-of select="wsi-log407:senderHostAndPort/*|wsi-log407:senderHostAndPort/text()"/>
				  </senderHostAndPort>
				  <receiverHostAndPort>
				    <xsl:copy-of select="wsi-log407:receiverHostAndPort/@*"/>
				    <xsl:copy-of select="wsi-log407:receiverHostAndPort/*|wsi-log407:receiverHostAndPort/text()"/>
				  </receiverHostAndPort>
				  <httpHeaders>
				    <xsl:call-template name='replaceHeaders'>
				      <xsl:with-param name="text">
					<xsl:choose>
					  <xsl:when test='contains(wsi-log407:httpHeaders, "&lt;?xml")
							  and contains(wsi-log407:messageContent, "&lt;?xml")'>
					    <xsl:value-of select="substring-before(wsi-log407:httpHeaders, '&lt;?xml')"/>
					  </xsl:when>
					  <xsl:otherwise>
					    <xsl:value-of select="wsi-log407:httpHeaders"/>
					  </xsl:otherwise>
					</xsl:choose>
				      </xsl:with-param>
				    </xsl:call-template>
				  </httpHeaders>
				  <content>
				    <xsl:choose>
				      <xsl:when test='contains($content, "&lt;!DOCTYPE") or contains(wsi-log407:httpHeaders, "Content-Type: application/x-www-form-urlencoded")'>					
					<xsl:value-of select="$content" />
				      </xsl:when>
				      <xsl:otherwise>
					<xsl:value-of select="$content" disable-output-escaping="yes"/>
				      </xsl:otherwise>
				    </xsl:choose>
				  </content>
				</message>
			</xsl:for-each>
		</log>
	</xsl:template>

	<xsl:template name="replaceHeaders">
	  <xsl:param name='text'/>

	  <xsl:choose>
	    <xsl:when test='contains($text, "&#xD;")'>
	      <xsl:call-template name='replaceHeaders'>
		<xsl:with-param name='text' select='substring-before($text, "&#xD;")'/>
	      </xsl:call-template>
	      <xsl:call-template name='replaceHeaders'>
		<xsl:with-param name='text' select='substring-after($text, "&#xD;")'/>
	      </xsl:call-template>
	    </xsl:when>
	    <xsl:when test='starts-with($text, "HTTP/1.")'>
	      <StatusCode value='{substring-before(substring-after($text, " "), " ")}'>
		<xsl:value-of select='$text'/>
	      </StatusCode>
	    </xsl:when>
	    <xsl:when test='starts-with($text, "POST ")'>
	      <Method value="POST">
		<xsl:call-template name='replaceURI'>
		  <xsl:with-param name='text' select='substring-before(substring-after($text, "POST "), " HTTP")'/>
		</xsl:call-template>
	      </Method>
	    </xsl:when>
	    <xsl:when test='starts-with($text, "PUT ")'>
	      <Method value="PUT">
		<xsl:call-template name='replaceURI'>
		  <xsl:with-param name='text' select='substring-before(substring-after($text, "PUT "), " HTTP")'/>
		</xsl:call-template>
	      </Method>
	    </xsl:when>
	    <xsl:when test='starts-with($text, "GET ")'>
	      <Method value="GET">
		<xsl:call-template name='replaceURI'>
		  <xsl:with-param name='text' select='substring-before(substring-after($text, "GET "), " HTTP")'/>
		</xsl:call-template>
	      </Method>
	    </xsl:when>
	    <xsl:when test='starts-with($text, "DELETE ")'>
	      <Method value="DELETE">
		<xsl:call-template name='replaceURI'>
		  <xsl:with-param name='text' select='substring-before(substring-after($text, "DELETE "), " HTTP")'/>
		</xsl:call-template>
	      </Method>
	    </xsl:when>
	    <xsl:when test='contains($text, ": ")'>
	      <xsl:variable name='name'>
		<xsl:value-of select='substring-before(normalize-space($text), ": ")'/>
	      </xsl:variable>
	      <xsl:element name='{$name}'>
		<xsl:variable name='content' select='substring-after($text, ": ")'/>
		<xsl:choose>
		  <xsl:when test='$name="Content-Type"'>
		    <xsl:call-template name='replaceContentType'>
		      <xsl:with-param name='text' select='$content' />
		    </xsl:call-template>
		  </xsl:when>
		  <xsl:otherwise>
		    <xsl:value-of select='$content'/>
		  </xsl:otherwise>
		</xsl:choose>
	      </xsl:element>
	    </xsl:when>
	    <xsl:otherwise>
	      <xsl:value-of select='$text' disable-output-escaping="yes"/>
	    </xsl:otherwise>
	  </xsl:choose>

	</xsl:template>

	<xsl:template name="replaceURI">
	  <xsl:param name='text'/>

	  <xsl:attribute name='rawURI'>
	    <xsl:value-of select='$text'/>
	  </xsl:attribute>
	  <xsl:choose>
	    <xsl:when test='contains($text, "?")'>
	      <uri><xsl:value-of select='substring-before($text, "?")'/></uri>
	      <xsl:call-template name='replaceParams'>
		<xsl:with-param name='text' select='substring-after($text, "?")'/>
		<xsl:with-param name='sep'>&amp;</xsl:with-param>
	      </xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
	      <uri><xsl:value-of select='$text'/></uri>
	    </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>

	<xsl:template name="replaceContentType">
	  <xsl:param name='text'/>

	  <xsl:choose>
	    <xsl:when test='contains($text, ";")'>
	      <xsl:attribute name="type"><xsl:value-of select='substring-before($text, ";")'/></xsl:attribute>
	      <xsl:call-template name='replaceParams'>
		<xsl:with-param name='text' select='substring-after($text, ";")'/>
		<xsl:with-param name='sep'>;</xsl:with-param>
	      </xsl:call-template>
	    </xsl:when>
	    <xsl:otherwise>
	      <xsl:attribute name="type"><xsl:value-of select='$text'/></xsl:attribute>
	    </xsl:otherwise>
	  </xsl:choose>
	</xsl:template>

	<xsl:template name="replaceParams">
	  <xsl:param name='text'/>
	  <xsl:param name='sep'/>

	  <xsl:choose>
	    <xsl:when test='contains($text, $sep)'>
	      <xsl:call-template name='replaceParams'>
		<xsl:with-param name='text' select='substring-before($text, $sep)'/>
		<xsl:with-param name='sep' select='$sep' />
	      </xsl:call-template>
	      <xsl:call-template name='replaceParams'>
		<xsl:with-param name='text' select='substring-after($text, $sep)'/>
		<xsl:with-param name='sep' select='$sep' />
	      </xsl:call-template>
	    </xsl:when>
	    <xsl:when test='contains($text, "=")'>
	      <xsl:element name='{normalize-space(substring-before($text, "="))}'>
		<xsl:variable name='value' select='substring-after($text, "=")'/>
		<xsl:choose>
		  <xsl:when test="starts-with($value, '&quot;') and substring($value, string-length($value), 1)">
		    <!-- remove quotes out of the value -->
		    <xsl:value-of select='substring($value, 2, string-length($value)-2)'/>
		  </xsl:when>
		  <xsl:otherwise><xsl:value-of select='$value'/></xsl:otherwise>
		</xsl:choose>
	      </xsl:element>
	    </xsl:when>
	  </xsl:choose>

	</xsl:template>

	<!-- http://xsltsl.sourceforge.net/ -->
	<xsl:template name="replaceContent">
		<xsl:param name="text"/>
		<xsl:param name="replace"/>
		<xsl:param name="with"/>
		<xsl:param name="disable-output-escaping">no</xsl:param>
		<xsl:choose>
			<xsl:when test="string-length($replace) = 0 and $disable-output-escaping = 'yes'">
				<xsl:value-of select="$text" disable-output-escaping="yes"/>
			</xsl:when>
			<xsl:when test="string-length($replace) = 0">
				<xsl:value-of select="$text"/>
			</xsl:when>
			<xsl:when test="contains($text, $replace)">
				<xsl:variable name="before" select="substring-before($text, $replace)"/>
				<xsl:variable name="after" select="substring-after($text, $replace)"/>
				<xsl:choose>
					<xsl:when test='$disable-output-escaping = "yes"'>
						<xsl:value-of select="$before" disable-output-escaping="yes"/>
						<xsl:value-of select="$with" disable-output-escaping="yes"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$before"/>
						<xsl:value-of select="$with"/>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="replaceContent">
					<xsl:with-param name="text" select="$after"/>
					<xsl:with-param name="replace" select="$replace"/>
					<xsl:with-param name="with" select="$with"/>
					<xsl:with-param name="disable-output-escaping" select="$disable-output-escaping"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test='$disable-output-escaping = "yes"'>
				<xsl:value-of select="$text" disable-output-escaping="yes"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
