<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html"/>
	
	<xsl:variable name="implementations" select="document('../desc/test-suite/results/implementations.xml')"/>

	<xsl:template match="comparing">
		<html>
			<head>
				<title>Test Pass Results</title>
				<link rel="stylesheet" type="text/css"
					href="http://www.w3.org/StyleSheets/TR/base.css"/>
			</head>
			<body>
				<h3>Test Pass Results</h3>
				<p>Comparing <a href="{@aspirant}"><xsl:value-of select="@aspirant"/></a> with <a href="{@archetype}"><xsl:value-of select="@archetype"/></a> for testcase <a href="{@source}"><xsl:value-of select="@source"/></a> (<a href="{@test-metadata}">TestMetadata</a>).</p>
				<xsl:for-each select="failure">
					<dl>
						<dt>xpath: <xsl:value-of select="@xpath"/> (near xml:id="<xsl:value-of select="@nearest-id"/>")</dt>
						<dd><xsl:copy-of select="node()"/></dd>
					</dl>
				</xsl:for-each>
				<div style="background-color:yellow">
					<xsl:value-of select="no-aspirant | no-archetype"/>
				</div>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>

