<?xml version="1.0" encoding="UTF-8"?>
<!--
	Generates summary of coverage.
-->
<xsl:stylesheet xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:wsdl="http://www.w3.org/2005/08/wsdl"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
	exclude-result-prefixes="xs wsdl">

	<xsl:output method="xml" indent="yes" />

	<xsl:param name="DSTAMP" />
	<xsl:param name="TSTAMP" />
	<xsl:param name="TODAY" />

	<xsl:variable name="reports"
		select="document('test-suite-reports.xml')//report" />

	<xsl:variable name="items" select="document($reports)//item" />

	<xsl:template match="/xpaths">
		<xsl:processing-instruction name="xml-stylesheet">type="text/xsl" href="coverage.xsl"</xsl:processing-instruction>
		<coverage>
			<DSTAMP>
				<xsl:value-of select="$DSTAMP" />
			</DSTAMP>
			<TSTAMP>
				<xsl:value-of select="$TSTAMP" />
			</TSTAMP>
			<TODAY>
				<xsl:value-of select="$TODAY" />
			</TODAY>
			<total>
				<xsl:value-of select="count($reports)" />
			</total>
			<good>
				<xsl:value-of
					select="count($reports[starts-with(.,'reports/documents/good')])" />
			</good>
			<bad>
				<xsl:value-of
					select="count($reports[starts-with(.,'reports/documents/bad')])" />
			</bad>
			<xsl:apply-templates select="xpath" />
		</coverage>
	</xsl:template>

	<xsl:template match="xpath">
		<xsl:variable name="xpath" select="normalize-space(.)" />
		<item>
			<xsl:attribute name="xpath">
				<xsl:value-of select="$xpath" />
			</xsl:attribute>
			<xsl:attribute name="count">
				<xsl:value-of
					select="sum($items[@xpath=$xpath]/@count)" />
			</xsl:attribute>
		</item>
	</xsl:template>

</xsl:stylesheet>