<?xml version="1.0" encoding="UTF-8"?>
<!--
	Generates the list of coverage reports for the test suite.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:tm="http://www.w3.org/2006/02/wsdl/TestMetadata" version="1.0" exclude-result-prefixes="tm">

	<xsl:output method="xml" indent="yes" />

	<xsl:template match="/test-suite">
		<reports>
			<xsl:apply-templates select="test-case[starts-with(@href,'documents')]" />
		</reports>
	</xsl:template>

	<xsl:template match="test-case">
		<xsl:variable name="id" select="@id" />
		<xsl:for-each select="document(@href)/tm:TestMetadata/tm:Inputs/tm:Input">
			<xsl:variable name="file" select="." />
			<xsl:variable name="base"
				select="substring-before($file,'.wsdl')" />
			<xsl:variable name="extension"
				select="substring-after($file,$base)" />
			<xsl:variable name="type">
				<xsl:choose>
					<xsl:when test="ancestor::tm:TestMetadata/tm:ExpectedResults/tm:Successful[.='true']">good</xsl:when>
					<xsl:otherwise>bad</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:if test="$extension='.wsdl'">
				<report>
					<xsl:value-of select="concat('reports/documents/',$type,'/',$id,'/',$base,'.xml')"/>
				</report>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>

</xsl:stylesheet>