<?xml version="1.0" encoding="UTF-8"?>
<!--
	Generates the expected validation report for the test suite.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:tm="http://www.w3.org/2006/02/wsdl/TestMetadata" version="1.0"
	exclude-result-prefixes="tm">

	<xsl:output method="xml" indent="yes" />

	<xsl:template match="/test-suite">
		<report
			xmlns='http://www.w3.org/2006/06/wsdl/ValidationReport'>
			<xsl:apply-templates />
		</report>
	</xsl:template>

	<xsl:template match="test-case">
		<xsl:variable name="id" select="@id" />
		<xsl:variable name="href" select="@href" />
		<xsl:for-each select="document(@href)/tm:TestMetadata">
			<xsl:variable name="Identifier"
				select="normalize-space(tm:Identifier)" />
			<xsl:variable name="Input-root"
				select="normalize-space(tm:Inputs/tm:Input[@role='root'])" />
			<wsdl>
				<uri>
					<xsl:value-of
						select="concat($Identifier,'/',$Input-root)" />
				</uri>
				<xsl:variable name="Successful"
					select="normalize-space(tm:ExpectedResults/tm:Successful)" />
				<success>
					<xsl:value-of select="$Successful" />
				</success>
				<xsl:variable name="severity">
					<xsl:if test="$Successful">warning</xsl:if>
					<xsl:if test="not($Successful)">error</xsl:if>
				</xsl:variable>
				<xsl:for-each
					select="tm:ExpectedResults/tm:ViolatesAssertion">
					<xsl:variable name="ViolatesAssertion"
						select="normalize-space(.)" />
					<xsl:element name="$severity">
						<key>
							<xsl:value-of select="$ViolatesAssertion" />
						</key>
					</xsl:element>
				</xsl:for-each>
			</wsdl>
		</xsl:for-each>
	</xsl:template>

</xsl:stylesheet>