<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<axsl:stylesheet xmlns:axsl="http://www.w3.org/1999/XSL/Transform" xmlns:sch="http://www.ascc.net/xml/schematron" version="1.0" xmlns:wsdl="http://www.w3.org/ns/wsdl" wsdl:dummy-for-xmlns="">
<axsl:output method="html"/>
<axsl:template mode="schematron-get-full-path" match="*|@*">
<axsl:apply-templates mode="schematron-get-full-path" select="parent::*"/>
<axsl:text>/</axsl:text>
<axsl:if test="count(. | ../@*) = count(../@*)">@</axsl:if>
<axsl:value-of select="name()"/>
<axsl:text>[</axsl:text>
<axsl:value-of select="1+count(preceding-sibling::*[name()=name(current())])"/>
<axsl:text>]</axsl:text>
</axsl:template>
<axsl:template match="/">
<html>
<style>
         a:link    { color: black}
         a:visited { color: gray}
         a:active  { color: #FF0088}
         h3        { background-color:black; color:white;
                     font-family:Arial Black; font-size:12pt; }
         h3.linked { background-color:black; color:white;
                     font-family:Arial Black; font-size:12pt; }
      </style>
<h2 title="Schematron contact-information is at the end of                   this page">
<font color="#FF0080">Schematron</font> Report
      </h2>
<h1 title=" ">W3C WSDL 2.0 Schematron Schema</h1>
<div class="errors">
<ul>
<h3>Check Generic Bindings</h3>
<axsl:apply-templates mode="M2" select="/"/>
</ul>
</div>
<hr color="#FF0080"/>
<p>
<font size="2">Schematron Report by David Carlisle.
      <a title="Link to the home page of the Schematron,                  a tree-pattern schema language" href="http://www.ascc.net/xml/resource/schematron/schematron.html">
<font color="#FF0080">The Schematron</font>
</a> by
      <a title="Email to Rick Jelliffe (pronounced RIK JELIF)" href="mailto:ricko@gate.sinica.edu.tw">Rick Jelliffe</a>,
      <a title="Link to home page of Academia Sinica" href="http://www.sinica.edu.tw">Academia Sinica Computing Centre</a>.
      </font>
</p>
</html>
</axsl:template>
<axsl:template mode="M2" priority="4000" match="wsdl:binding[not(@interface)]">
<axsl:if test="wsdl:operation">
<li>
<a title="Link to where this pattern was found" target="out" href="schematron-out.html#{generate-id(.)}">
<i/>Generic binding contains an operation.<b>The generic binding<axsl:text xml:space="preserve"> </axsl:text>
<axsl:value-of select="@name"/>
<axsl:text xml:space="preserve"> </axsl:text>contains the operation<axsl:text xml:space="preserve"> </axsl:text>
<axsl:value-of select="wsdl:operation[1]/@ref"/>
<axsl:text xml:space="preserve"> </axsl:text>
</b>
</a>
</li>
</axsl:if>
<axsl:apply-templates mode="M2"/>
</axsl:template>
<axsl:template mode="M2" priority="3999" match="wsdl:binding/wsdl:operation">
<axsl:choose>
<axsl:when test="../@interface"/>
<axsl:otherwise>
<li>
<a title="Link to where this pattern was expected" target="out" href="schematron-out.html#{generate-id(.)}">
<i/>An operation binding MUST belong to an interface.<b>operation<axsl:text xml:space="preserve"> </axsl:text>
<axsl:value-of select="@ref"/>
<axsl:text xml:space="preserve"> </axsl:text>is contained in generic binding<axsl:text xml:space="preserve"> </axsl:text>
<axsl:value-of select="../@name"/>
<axsl:text xml:space="preserve"> </axsl:text>
</b>
</a>
</li>
</axsl:otherwise>
</axsl:choose>
<axsl:apply-templates mode="M2"/>
</axsl:template>
<axsl:template mode="M2" priority="-1" match="text()"/>
<axsl:template priority="-1" match="text()"/>
</axsl:stylesheet>
