<?xml version="1.0"?>
<sch:schema xmlns:sch="http://www.ascc.net/xml/schematron">
	<sch:title>W3C WSDL 2.0 Schematron Schema</sch:title>
	<sch:ns prefix="wsdl" uri="http://www.w3.org/ns/wsdl" />
	<sch:pattern name="Check Generic Bindings">
		<sch:rule context="wsdl:binding[not(@interface)]">
			<sch:report test="wsdl:operation"
				diagnostics="report-operation">
				Generic binding contains an operation.
			</sch:report>
		</sch:rule>
		<sch:rule context="wsdl:binding/wsdl:operation">
			<sch:assert test="../@interface"
				diagnostics="generic-binding-contains-operation">
				An operation binding MUST belong to an interface.
			</sch:assert>
		</sch:rule>
	</sch:pattern>
	<sch:diagnostics>
		<sch:diagnostic id="generic-binding-contains-operation">
			operation
			<sch:value-of select="@ref" />
			is contained in generic binding
			<sch:value-of select="../@name" />
		</sch:diagnostic>
		<sch:diagnostic id="report-operation">
			The generic binding
			<sch:value-of select="@name" />
			contains the operation
			<sch:value-of select="wsdl:operation[1]/@ref" />
		</sch:diagnostic>
	</sch:diagnostics>
</sch:schema>

