<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<!-- 
	
	Schematron Schema for WSDL 2.0 Component Model Interchange Format
	
	This format is used to compare component model instances computed by different implementation.
	
	ChangeLog:
	
	2006-11-13 Arthur Ryman (ryman@ca.ibm.com)
	- created
	
-->
<sch:schema xmlns:sch="http://www.ascc.net/xml/schematron">

	<sch:title>
		W3C WSDL 2.0 Component Model Interchange Format Schematron
		Schema
	</sch:title>
	
	<sch:ns prefix="cm"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component" />
	<sch:ns prefix="cmbase"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component-base" />
	<sch:ns prefix="cmextensions"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component-extensions" />
	<sch:ns prefix="cmhttp"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component-http" />
	<sch:ns prefix="cmrpc"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component-rpc" />
	<sch:ns prefix="cmsoap"
		uri="http://www.w3.org/2002/ws/desc/wsdl/component-soap" />

	<sch:pattern name="RPC Interface Operation Extension">
		<sch:rule context="wsdl:binding[not(@interface)]">
			<sch:report test="wsdl:operation"
				diagnostics="report-operation">
				Generic binding contains an operation.
			</sch:report>
		</sch:rule>
		<sch:rule context="wsdl:binding/wsdl:operation">
			<sch:assert test="../@interface"
				diagnostics="generic-binding-contains-operation">
				An operation binding MUST belong to an interface.
			</sch:assert>
		</sch:rule>
	</sch:pattern>
	
	<sch:diagnostics>
		<sch:diagnostic id="generic-binding-contains-operation">
			operation
			<sch:value-of select="@ref" />
			is contained in generic binding
			<sch:value-of select="../@name" />
		</sch:diagnostic>
		<sch:diagnostic id="report-operation">
			The generic binding
			<sch:value-of select="@name" />
			contains the operation
			<sch:value-of select="wsdl:operation[1]/@ref" />
		</sch:diagnostic>
	</sch:diagnostics>

</sch:schema>