<?xml version="1.0" encoding="utf-8"?>

<!-- 
	
	Transforms a WSDL 2.0 document into a statistical report of element and attribute coverage.
	
	ChangeLog:
	
	2005-11-09 Arthur Ryman <ryman@ca.ibm.com>
	- created
	
	2006-02-19 Arthur Ryman <ryman@ca.ibm.com>
	- updated wsdl namespace
	
	2006-06-28 Arthur Ryman <ryman@ca.ibm.com>
	- removed exclude-output-prefixes attribute to work around a problem
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:wsdl="http://www.w3.org/ns/wsdl"
	xmlns:wsdlx="http://www.w3.org/ns/wsdl-extensions"
	xmlns:wrpc="http://www.w3.org/ns/wsdl/rpc"
	xmlns:whttp="http://www.w3.org/ns/wsdl/http"
	xmlns:wsoap="http://www.w3.org/ns/wsdl/soap"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" version="1.0">

	<xsl:output method="xml" indent="yes" />

	<xsl:template match="/xpaths">
		<xsl:comment>
			This stylesheet has been automatically generated. Do NOT
			edit it!
		</xsl:comment>
		<xsl:element name="xsl:stylesheet">
			<xsl:attribute name="version">1.0</xsl:attribute>
			<xsl:element name="xsl:output">
				<xsl:attribute name="method">xml</xsl:attribute>
				<xsl:attribute name="indent">yes</xsl:attribute>
			</xsl:element>

			<xsl:element name="xsl:template">
				<xsl:attribute name="match">/</xsl:attribute>
				<coverage>
					<xsl:apply-templates select="xpath" />
				</coverage>
			</xsl:element>
		</xsl:element>
	</xsl:template>

	<xsl:template match="xpath">
		<xsl:variable name="xpath" select="normalize-space(.)" />
		<xsl:element name="xsl:if">
			<xsl:attribute name="test">
				<xsl:text>count(</xsl:text>
				<xsl:value-of select="$xpath" />
				<xsl:text>) > 0</xsl:text>
			</xsl:attribute>
			<item>
				<xsl:attribute name="xpath">
					<xsl:value-of select="$xpath" />
				</xsl:attribute>
				<xsl:attribute name="count">
					<xsl:text>{count(</xsl:text>
					<xsl:value-of select="$xpath" />
					<xsl:text>)}</xsl:text>
				</xsl:attribute>
			</item>
		</xsl:element>
	</xsl:template>

</xsl:stylesheet>